/**
 * @(#)AhaProperties.java 1.0    1999/14/09
 *
 * Copyright (c) 1998, 1999 Eindhoven University of Technology. All Rights Reserved.
 *
 * This software is proprietary information of the Eindhoven University
 * of Technology. It may be used according to the GNU license.
 *
 */

package AHA;

import java.util.Enumeration;
import java.io.*;
import java.util.Properties;

/**
 * AhaProperties contains the properties from the Course's properties file.
 * See documentation which properties.
 */

public class AhaProperties {
	private AHA AHA;
	private Properties Props;

	public AhaProperties(AHA AHA) throws AhaException{
		this.AHA = AHA;
		Props = new Properties();
		InputStream is;
		String propfile="";
		try {
			propfile = new FileName(AHA.getHtDocs(),AHA.getCourse(),AHA.getPropertyFile()).toString();
			is = new FileInputStream(propfile);
			Props.load(is);
			System.out.println("Properties read from "+propfile+".");

			Enumeration e = Props.propertyNames();
			while(e.hasMoreElements()) {
				String key= (String)e.nextElement();
				String value=Props.getProperty(key);
				Props.setProperty(key.toLowerCase(), value);
			}
		} catch (Exception ioe) {
			String error = "An error occurred while reading the properties file: "+propfile+".";
			System.out.println(error);
			throw new AhaException(error);
		}                                      
	}
	public void list(PrintStream out) {
		Props.list(out);
	}
	public String getProperty(String key) {
		return Props.getProperty(key);
	}
}