/*
 * @(#)CgiUtil.java	1.0	98/08/03
 *
 * Copyright (c) 1998 Eindhoven University of Technology. All Rights Rserved.
 *
 * This software is proprietary information of the Eindhoven University
 * of Technology. It may be used according to the GNU license.
 *
 */

package AHA;

import java.util.Hashtable;
import java.io.*;
import java.lang.String;

/**
 * CgiUtil is used to read Forms input (from a POST request)
 * and to store that input in a HashTable.
 * This class is not strictly needed anymore for the servlet,
 * but is kept for now because it already existed for the CGI version.
 * (And if it ain't broke, don't fix it, right?)
 */
public class CgiUtil extends Hashtable {

  private int cl = 0;
  private byte[] byteline;
  private String linestr;

  /**
   * The default constructor does nothing.
   */
  CgiUtil() {
    ;
  }

  /**
   * This constructor reads the input from the POST request and
   * stores it in a HashTable.
   *
   * @exception	AhaException	If there is an error in the forms input.
   */
	public CgiUtil(InputStream in, int ContentLength)
    throws AhaException
  {
    super(10, (float)0.1);
    String attribute;
    String value;
    cl = ContentLength;
    if (cl > 0) { // otherwise no real forms input
      byteline = new byte[cl];
      try {
	int i = in.read(byteline, 0, cl);
	if (i != cl)
	  throw new AhaException("Internal Error: Inconsistent Forms input delivered.");
      } catch (IOException e) {
	throw new AhaException("I/O error while reading forms input");
      }
      
      linestr = new String(byteline);
      int low = 0, high;
      while (low < cl) {
	high = linestr.indexOf('=', low);
	if (high == -1) // this is actually an error
	  throw new AhaException("Forms input does not end with '='.");
	attribute = linestr.substring(low, high);
	low = high+1;
	high = linestr.indexOf('&', low);
	if (high == -1) { // this happens with the last value
	  value = linestr.substring(low, cl);
	  value = value.replace('+', ' ');
	  value = UnescapeUrl(value);
	  this.put(attribute, value);
	  break;
	} else {
	  value = linestr.substring(low, high);
	  value = value.replace('+', ' '); // plustospace
	  value = UnescapeUrl(value);
	}
	low = high+1;
	this.put(attribute, value);
      }
    }
  }

  /**
   * UnescapeUrl removes urlencoding from a string.
   *
   * @exception	AhaException	If there is a syntax error in the urlencoding.
   */
  String UnescapeUrl(String s)
    throws AhaException
  {
    char[] u = s.toCharArray(); // easier to work with
    String t;
    int x, y;
    for (x=0,y=0; y < u.length;++x,++y) {
      if ((u[x]=u[y]) == '%') {
	// construct and decode the 2-char hex number
	t = new String(u, y+1, 2);
	t = "0x" + t;
	try {
	  u[x] = (char)Integer.decode(t).intValue();
	} catch (NumberFormatException e) {
	  throw new AhaException("Error in special characters in Form input.");
	}
	y+=2;
      }
    }
    return String.copyValueOf(u, 0, x);
  }
}
