package AHA;

import java.net.*;
import java.util.*;
import java.text.*;
import java.awt.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class ColorConfig extends AhaServlet {
	public void init(ServletConfig config) throws ServletException {
		super.init(config);
	}

	protected void service(	HttpServletRequest request, 
				HttpServletResponse response) {
		try {
			super.initService(request,response);
		} catch (AhaException ahae) {
			System.out.println(getName()+" error: "+ahae.toString());
			super.redirect(request, response);
			return;
		}

		String ChangeCgi = AHA.getServletDir() + "/ColorChange/"+Course+"/"+UserModel.getId();
		AHA.setWriter(out);
		genConfig(out, ChangeCgi);
	}



  /**
   * This method writes out the user model as an HTML form that can be used
   * for updating the model.
   * There are two String parameters: a title to use for the HTML page and
   * a URL for the script or servlet to handle the submitted form.
   */
  public void genConfig(PrintWriter out, String ChangeCgi) {
    String Title = AHA.getTitle();
    out.println("<H1>" + Title + "</H1>");
    out.println("<H3>Configuration Setup for " + UserModel.getName() + "</H3>");
    out.println("<FORM METHOD=\"POST\" ACTION=\"" + ChangeCgi + "\">");

    out.println("<H3>Part A: Color Preferences</H3>");
    out.println("<P>\nOnly change the colors you want. The others will remain as they are now.\n</P>");

    Color [] colors = { Color.black, Color.blue, Color.cyan, Color.gray,
			Color.green, Color.magenta, Color.orange, Color.pink,
			Color.red, Color.yellow };
    String [] colornames = { "black", "blue", "cyan", "gray", "green", "magenta", "orange", "pink", "red", "yellow" };
    
    out.println("<DL>");
    out.println("<DT><B>External (unvisited) links:</B> currently <FONT COLOR=\"" +  UserModel.printExternalLinkColor() + "\">this color</FONT>.<BR>\n<DD>Choose color: ");
    for (int c = 0; c < colors.length; ++c) {
      out.print("<INPUT TYPE=\"RADIO\" NAME=\"ExternalLinkColor\" VALUE=\"" + UserModel.printColor(colors[c]) + "\">");
      out.println("&nbsp;<FONT COLOR=\"" + UserModel.printColor(colors[c]) + "\">" + colornames[c] + "</FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    }
    out.println("<BR>Choose brightness: ");
    out.println("<INPUT TYPE=\"RADIO\" NAME=\"ExternalLinkBrightNess\" VALUE=\"darker\">&nbsp;darker&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    out.println("<INPUT TYPE=\"RADIO\" NAME=\"ExternalLinkBrightNess\" VALUE=\"normal\">&nbsp;normal&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    out.println("<INPUT TYPE=\"RADIO\" NAME=\"ExternalLinkBrightNess\" VALUE=\"lighter\">&nbsp;lighter\n<BR><BR>");
    out.println("<DT><B>External visited links:</B> currently <FONT COLOR=\"" +  UserModel.printExternalVisitedColor() + "\">this color</FONT>.<BR>\n<DD>Choose color: ");
    for (int c = 0; c < colors.length; ++c) {
      out.print("<INPUT TYPE=\"RADIO\" NAME=\"ExternalVisitedColor\" VALUE=\"" + UserModel.printColor(colors[c]) + "\">");
      out.println("&nbsp;<FONT COLOR=\"" + UserModel.printColor(colors[c]) + "\">" + colornames[c] + "</FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    }
    out.println("<BR>Choose brightness: ");
    out.println("<INPUT TYPE=\"RADIO\" NAME=\"ExternalVisitedBrightNess\" VALUE=\"darker\">&nbsp;darker&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    out.println("<INPUT TYPE=\"RADIO\" NAME=\"ExternalVisitedBrightNess\" VALUE=\"normal\">&nbsp;normal&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    out.println("<INPUT TYPE=\"RADIO\" NAME=\"ExternalVisitedBrightNess\" VALUE=\"lighter\">&nbsp;lighter\n<BR><BR>");
    out.println("<DT><B>Active links:</B> currently <FONT COLOR=\"" +  UserModel.printActiveLinkColor() + "\">this color</FONT>.<BR>\n<DD>Choose color: ");
    for (int c = 0; c < colors.length; ++c) {
      out.print("<INPUT TYPE=\"RADIO\" NAME=\"ActiveLinkColor\" VALUE=\"" + UserModel.printColor(colors[c]) + "\">");
      out.println("&nbsp;<FONT COLOR=\"" + UserModel.printColor(colors[c]) + "\">" + colornames[c] + "</FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    }
    out.println("<BR>Choose brightness: ");
    out.println("<INPUT TYPE=\"RADIO\" NAME=\"ActiveLinkBrightNess\" VALUE=\"darker\">&nbsp;darker&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    out.println("<INPUT TYPE=\"RADIO\" NAME=\"ActiveLinkBrightNess\" VALUE=\"normal\">&nbsp;normal&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    out.println("<INPUT TYPE=\"RADIO\" NAME=\"ActiveLinkBrightNess\" VALUE=\"lighter\">&nbsp;lighter\n<BR><BR>");
    out.println("<DT><B>Internal recommended links:</B> currently <FONT COLOR=\"" +  UserModel.printGoodLinkColor() + "\">this color</FONT>.<BR>\n<DD>Choose color: ");
    for (int c = 0; c < colors.length; ++c) {
      out.print("<INPUT TYPE=\"RADIO\" NAME=\"GoodLinkColor\" VALUE=\"" + UserModel.printColor(colors[c]) + "\">");
      out.println("&nbsp;<FONT COLOR=\"" + UserModel.printColor(colors[c]) + "\">" + colornames[c] + "</FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    }
    out.println("<BR>Choose brightness: ");
    out.println("<INPUT TYPE=\"RADIO\" NAME=\"GoodLinkBrightNess\" VALUE=\"darker\">&nbsp;darker&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    out.println("<INPUT TYPE=\"RADIO\" NAME=\"GoodLinkBrightNess\" VALUE=\"normal\">&nbsp;normal&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    out.println("<INPUT TYPE=\"RADIO\" NAME=\"GoodLinkBrightNess\" VALUE=\"lighter\">&nbsp;lighter\n<BR><BR>");
    out.println("<DT><B>Internal to-be-avoided links:</B> currently <FONT COLOR=\"" +  UserModel.printBadLinkColor() + "\">this color</FONT>.<BR>\n<DD>Choose color: ");
    for (int c = 0; c < colors.length; ++c) {
      out.print("<INPUT TYPE=\"RADIO\" NAME=\"BadLinkColor\" VALUE=\"" + UserModel.printColor(colors[c]) + "\">");
      out.println("&nbsp;<FONT COLOR=\"" + UserModel.printColor(colors[c]) + "\">" + colornames[c] + "</FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    }
    out.println("<BR>Choose brightness: ");
    out.println("<INPUT TYPE=\"RADIO\" NAME=\"BadLinkBrightNess\" VALUE=\"darker\">&nbsp;darker&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    out.println("<INPUT TYPE=\"RADIO\" NAME=\"BadLinkBrightNess\" VALUE=\"normal\">&nbsp;normal&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    out.println("<INPUT TYPE=\"RADIO\" NAME=\"BadLinkBrightNess\" VALUE=\"lighter\">&nbsp;lighter\n<BR><BR>");


    out.println("<DT><B>Internal neutral links:</B> currently <FONT COLOR=\"" +  UserModel.printNeutralLinkColor() + "\">this color</FONT>.<BR>\n<DD>Choose color: ");
    for (int c = 0; c < colors.length; ++c) {
      out.print("<INPUT TYPE=\"RADIO\" NAME=\"NeutralLinkColor\" VALUE=\"" + UserModel.printColor(colors[c]) + "\">");
      out.println("&nbsp;<FONT COLOR=\"" + UserModel.printColor(colors[c]) + "\">" + colornames[c] + "</FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    }
    out.println("<BR>Choose brightness: ");
    out.println("<INPUT TYPE=\"RADIO\" NAME=\"NeutralLinkBrightNess\" VALUE=\"darker\">&nbsp;darker&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    out.println("<INPUT TYPE=\"RADIO\" NAME=\"NeutralLinkBrightNess\" VALUE=\"normal\">&nbsp;normal&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    out.println("<INPUT TYPE=\"RADIO\" NAME=\"NeutralLinkBrightNess\" VALUE=\"lighter\">&nbsp;lighter\n");
    out.println("</DL>");

    out.println("<INPUT TYPE=\"SUBMIT\" VALUE=\"Effectuate Changes\">");
    out.println("<INPUT TYPE=\"RESET\" VALUE=\"Reset to Previous Settings\">");
    out.println("</FORM>");
  }

}