/*
 * @(#)Derive.java 1.0    1999/14/09
 *
 * Copyright (c) 1998, 1999 Eindhoven University of Technology. All Rights Reserved.
 *
 * This software is proprietary information of the Eindhoven University
 * of Technology. It may be used according to the GNU license.
 *
 */

package AHA;

/**
 * Derive is a utility class, used for deriving information from an URL
 * If the requested information is not available then a AhaException is thrown.
 */

public class Derive{
	private String URI;
	// http://host:port/servlet/AHA/servlet_name/course/login/xmlfile

	/**
	 * The normal constructor. Stores a url-String.
	 */
	public Derive(String uri) {
		URI = uri;
	}

	/**
	 * The method getLoginid returns the loginid information from the url-String.
	 */
	public String getLoginid() throws AhaException {
		// /servlet/AHA/Get/course/login/page.xml
		int begin = URI.indexOf("/servlet/AHA/")+14;
		begin = URI.indexOf("/", begin) + 1;
		begin = URI.indexOf("/", begin) + 1;
		int end = URI.indexOf("/", begin);
		if (end == -1) 
			end = URI.length();
		String id;
		try {
			id = URI.substring(begin, end);
		} catch (Exception e) {
			throw new AhaException("Unable to derive loginname information from url.");
		}
		return id;
	}

	/**
	 * This filters out the course from the url-String
	 */
	public String getCourse() throws AhaException {
		// /servlet/AHA/Get/course/login/page.xml
		int begin = URI.indexOf("/servlet/AHA/")+14;
		begin = URI.indexOf("/", begin) +1 ;
		int end = URI.indexOf("/", begin);
		String course;
		try {
			course = URI.substring(begin, end);
		} catch (Exception e) {
			throw new AhaException("Unable to derive course information from url.");
		}
		return course;
	}

	
	/**
	 * Returns the name of a testfile from the url-String	
	 */
	public String getTest() throws AhaException {
		int begin = URI.lastIndexOf("/") + 1;
		String testfile;
		try {
			testfile = URI.substring(begin);
		} catch (Exception e) {
			throw new AhaException("Unable to derive test information from url.");
		}
		return testfile;
	}		

	/**
	 * Returns the name of a docfile from the url-String
	 */
	public String getDoc() throws AhaException {
		int begin = URI.lastIndexOf("/") + 1;
		String file;
		try {
			file = URI.substring(begin);
		} catch (Exception e) {
			throw new AhaException("Unable to derive document information from url.");
		}
		return file;
	}
}