/**
 * @(#)DoTest.java 1.0    1999/14/09
 *
 * Copyright (c) 1998, 1999 Eindhoven University of Technology. All Rights Reserved.
 *
 * This software is proprietary information of the Eindhoven University
 * of Technology. It may be used according to the GNU license.
 *
 */

package AHA;

import java.net.*;
import java.util.*;
import java.text.*;
import java.awt.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 * This class activates a filter which generates a HTML-form 
 * with a test that a user can do.
 * The results of the test will be checked by EvaluateTest.
 */

public class DoTest extends AhaServlet {

	private boolean debug = false;
	public void println(Object s) {if (debug) System.out.println(s.toString());}
	public void print(Object s) {if (debug) System.out.print(s.toString());}

	public void init(ServletConfig config) throws ServletException {
		super.init(config);

	}

	protected void service(	HttpServletRequest request, 
				HttpServletResponse response) {
		try {
			super.initService(request,response);
		} catch (AhaException ahae) {
			System.out.println(getName()+" error: "+ahae.toString());
			super.redirect(request, response);
			return;
		}

		try {
			Messages Messages = AHA.getMessages();
			String uri = request.getRequestURI();
			if (uri.indexOf("/DoTest/")>-1) {
				// first get the name of the test
				String test = new Derive(uri).getTest();
				// build an absolute path to the testfile
				String testloc = new FileName(HtDocs, Course, AHA.getTest(), test).toString();
				println(testloc);

				// build a form-action url
				String QuizCgi = AHA.getServletDir()+ "/EvaluateTest/" + Course + "/" + loginid + "/" + test;
				println(loginid+" does test "+testloc);

				// filter the test
				FilterTest filtertest = new FilterTest(AHA, testloc);
				// dump the test to out.
				filtertest.PrintQuestions(QuizCgi);
			} else {
				throw new AhaException("Error: wrong test call. Please notify the author about this error."); 
			}
		} catch (Exception e) {
			PrintWriter out = null;
			try {
				out = response.getWriter();
			} catch (IOException ioe) {
				println("DoTest: IO error");
			}
			if (out !=null ) {
				AHA.setWriter(out);
				Messages Messages = AHA.getMessages();
				Messages.Fatal(e.toString());
				out.close();
			}
		}
	}
}
