package AHA;

import java.io.*;
import javax.servlet.http.*;
import javax.servlet.*;
import java.net.URL;
import java.net.MalformedURLException;
import java.util.Enumeration;
public class Entree extends AhaServlet {

	protected String passwd;
	private boolean debug = false;
	public void println(Object s) { if (debug) System.out.println(s.toString());}
	public void init(ServletConfig config) throws ServletException {
		super.init(config);
	}
		
	public boolean exists(String dirname) {
		boolean b=false;
		File dir = new File(dirname);
		b = dir.exists();
		return b;
	}	
	public boolean hasGoodPasswd(String loginpasswd, String passwd) {
		return passwd.equals(loginpasswd);
	}


	protected void service(HttpServletRequest request, HttpServletResponse response) {
		loginid = request.getParameter("id").trim();
		passwd = request.getParameter("passwd").trim();
		HtDocs = request.getParameter("htdocs").trim();
		Course = request.getParameter("course").trim();
		Logs = request.getParameter("logs").trim();
		Title = request.getParameter("title").trim();
		Background = request.getParameter("background").trim();
		Language = request.getParameter("language").trim();
		try {
			out = response.getWriter();
		} catch (IOException ioe) {
			System.out.println("No writer.");
		}
	}


	public void buildAHA(HttpServletRequest request, HttpServletResponse response) throws AhaException{
	      	        String uri = javax.servlet.http.HttpUtils.getRequestURL(request).toString();
			String referer = request.getHeader("referer");
			System.out.println(uri);
			System.out.println(referer);

		// all variables are known, now build the AHA object
		AHA = new AHA(HtDocs, Logs, Course, Title, Background, Language);
		String usermodeldir = Logs+"/"+Course+"/"+loginid;
		boolean exist = exists(usermodeldir+"/model");
		if (exist) {
			try {
				UserModel = new UserModel(AHA,usermodeldir);
			} catch (Exception e) {
				throw new AhaException("The usermodel of "+loginid+" is not readable.");
			}
			AHA.setUserModel(UserModel);
			if (!hasGoodPasswd(passwd, UserModel.getPasswd())) {
				System.out.println("User " + loginid + " filled in a wrong password.");
				throw new AhaException("User " + loginid + " filled in a wrong password.");
			}
		} else {
			throw new AhaException("User " + loginid + "does not exist.");
		}
	}

	public void addAHAInformation(HttpServletRequest request, HttpServletResponse response) throws AhaException{
		// Add some information to AHA
		try {
	      	        String uri = javax.servlet.http.HttpUtils.getRequestURL(request).toString();
			System.out.println(uri);
        	        URL url = new URL(uri);
			Host = url.getHost();
	                Port = url.getPort();
		        if (Port <0 ) {
        			// this should not happen
				Port = 80;
			}

			AHA.setHost(Host);
			AHA.setPort(Port);
		} catch (MalformedURLException mue) {
			System.out.println("Host en Port zijn niet goed");
			throw new AhaException(mue.toString());
		}
		try {
			AhaProperties AhaProperties = new AhaProperties(AHA);
			AHA.setAhaProperties(AhaProperties);
		} catch (AhaException ahae) {
			throw new AhaException(ahae.toString());
		}

		GenerateList GenerateList = new GenerateList(AHA);
		AHA.setGenerateList(GenerateList);
		RequirementList RequirementList = new RequirementList(AHA);
		AHA.setRequirementList(RequirementList);
		Messages Messages = new Messages(AHA);
		AHA.setMessages(Messages);

	}

	public void addSessionInformation(HttpServletRequest request, HttpServletResponse response) throws AhaException{
		// Now make a session and put AHA in it;
		HttpSession session;
		session = request.getSession(false);
		if (session == null) {
			session = request.getSession(true);
		} else  {
			System.out.println("Er is al een sessie.");
		}
		session.setMaxInactiveInterval(-1);
		AHASession ses = new AHASession(AHA, session);
		ServletContext sc = (ServletContext)this.getServletContext();
		AHASession ses2 = (AHASession)sc.getAttribute(loginid+"@"+Course);
		if (ses2 != null) {
			System.out.println("Dezelfde user zit al op dezelfde cursus ingelogd.");
			System.out.println("Het systeem overschrijft de oude sessie.");
		}
		sc.setAttribute(loginid+"@"+Course, ses);
		
		System.out.println("User "+loginid+" logged in.");
	}
	
	public void redirect(HttpServletRequest request, HttpServletResponse response) {
		String redirecturi = AHA.getServletDir() +"/Get/" + Course +"/"+ loginid +"/"+ AHA.getFirstDocument();
		try {
			response.sendRedirect(redirecturi);
		} catch (IOException ioe) {System.out.println(ioe.toString());}
	}

	// Not used: CHANGE
	public void CheckOtherSessions(ServletContext sc) {
		Enumeration e = sc.getAttributeNames();
		while (e.hasMoreElements()) {
			String key = (String)e.nextElement();
			AHASession ses = (AHASession)sc.getAttribute(key);
			System.out.println(key+", "+ses.getSession().getId());
		}
	}
}