package AHA;

import java.net.*;
import java.util.*;
import java.text.*;
import java.awt.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class EvaluateTest extends AhaServlet {

	private boolean debug = false;

	public void println(Object s) {if (debug) System.out.println(s.toString());}
	public void print(Object s) {if (debug) System.out.print(s.toString());}
	
	public void init(ServletConfig config) throws ServletException {
		super.init(config);
	}

	protected void service(	HttpServletRequest request, 
				HttpServletResponse response) {
		try {
			super.initService(request,response);
		} catch (AhaException ahae) {
			System.out.println(getName()+" error: "+ahae.toString());
			super.redirect(request, response);
			return;
		}

		String Score;
		try {
			CgiUtil Util = new CgiUtil(request.getInputStream(), request.getContentLength());
                        String uri = request.getRequestURI();
			String test;
                        if (uri.indexOf("/EvaluateTest/")>-1) {
				test = new Derive(uri).getTest();
                        } else {
                                throw new AhaException("Error: wrong test call. Please notify the author about this error.");
                        }
			String FullDocName = HtDocs+"/"+Course+"/"+AHA.getTest()+"/"+test;
			File docfile = new File(FullDocName);
			if (!docfile.canRead())
				throw new AhaException("Cannot access the test file "+FullDocName+" on the server. Please notify the author about this.");
			FilterTest filtertest = new FilterTest(AHA, FullDocName);
			Score = filtertest.EvalQuestions(Util);
			println(Score);
		} catch (Exception e) {
			out.println("EvaluateTest Error: "+e.toString());
		}
	}

	private String deriveTest(String uri) throws AhaException {
	// /servlet/AHA/DoTest/COURSE/ID/testfile
		System.out.println(uri);
		int begin = uri.lastIndexOf("/") + 1;
		if (begin == -1) 
			throw new AhaException("Error: No such test");
		String testfile = uri.substring(begin);
		return testfile;
	}		
}

