/**
 * @(#)FileName.java 1.0    1999/14/09
 *
 * Copyright (c) 1998, 1999 Eindhoven University of Technology. All Rights Reserved.
 *
 * This software is proprietary information of the Eindhoven University
 * of Technology. It may be used according to the GNU license.
 *
 */

package AHA;

/**
 * FileName is a small utility, used for building good filename paths
 * with respect to the File.Separator used by de operating system.<p>
 * The arguments for the constructors will be glued together by File separators.<p>
 * String docfilename = new FileName(a, b, c).toString();<p>
 * will result in : docfilename == a/b/c on a unix filesystem.<p>
 */

public class FileName {
	String name;

	public FileName(String a, String b) {
		name = a+Utils.SEP+b;
	}

	public FileName(String a, String b, String c) {
		name = new FileName(a,b).toString()+Utils.SEP+c;
	}

	public FileName(String a, String b, String c, String d) {
		name = new FileName(a,b,c)+Utils.SEP+d;
	}

	public FileName(String a, String b, String c, String d, String e) {
		name = new FileName(a,b,c,d)+Utils.SEP+e;
	}

	public String toString() {
		return name;
	}
}