package AHA;

import java.lang.StringBuffer;
import java.io.*;

public class GenHTMLQuestions {

  private StringBuffer HTMLBuf; // Buffer used to save HTML code in


  /* main constructor
     Pre: the file in which the html-questions are stored exists
     Post: The html page in which the questions can be generated is stored
         in HTMLBuf  
  */
  public GenHTMLQuestions(String name,String title,int number,int show,boolean verbose,int maxanswers) 
  throws AhaException {

    HTMLBuf=new StringBuffer();
    addHeader(name,title,number,show,verbose,maxanswers);
    addQuestions(number,maxanswers);
    addFooter();	

  }

  /* Post: The HTML Buffer (=the page) is returned
  */
  public StringBuffer getHTMLBuf() {

    return HTMLBuf;
  }

  /* Post: HTMLBuf contains the header of the page 
  */
  public void addHeader(String name, String title,int number,int show,boolean verbose,int maxanswers) {

    addHTMLBuffer("<center><H1>"+title+"</H1></center>"); 
    addHTMLBuffer("<FORM METHOD=POST ACTION=\"SecondStepTestDevelopment\" TITLE=\"GenTest\">");
    addHTMLBuffer("<INPUT TYPE=\"hidden\" NAME=\"name\" VALUE=\""+name+"\">");
    addHTMLBuffer("<INPUT TYPE=\"hidden\" NAME=\"title\" VALUE=\""+title+"\">");
    addHTMLBuffer("<INPUT TYPE=\"hidden\" NAME=\"number\" VALUE=\""+number+"\">");
    addHTMLBuffer("<INPUT TYPE=\"hidden\" NAME=\"show\" VALUE=\""+show+"\">");
    addHTMLBuffer("<INPUT TYPE=\"hidden\" NAME=\"verbose\" VALUE=\""+verbose+"\">");
    addHTMLBuffer("<INPUT TYPE=\"hidden\" NAME=\"maxanswers\" VALUE=\""+maxanswers+"\">");	
  }  

  /* Post: The footer of the page is stored in HTMLBuf 
  */
  public void addFooter() {
 
    addHTMLBuffer("<P><HR>");
    addHTMLBuffer("<center><INPUT TYPE=\"submit\" VALUE=\"OK\"></center>");
    addHTMLBuffer("</FORM>");
  }


  /* read the standard structure of a question
     returns the number of lines read
  */

  /* Post: count question input field are added to HTML buffer 
  */
  public void addQuestions(int count,int maxanswers) {

      for(int qi=1;qi<=count;qi++) {
	addHTMLBuffer("<HR> Question "+qi+": <BR>");
	// Add the question textfield
	addHTMLBuffer("<TEXTAREA NAME=\"question"+qi+"\" ROWS=\"2\" COLS=\"64\" WRAP=\"physical\"></TEXTAREA>");	
	addHTMLBuffer("<OL TYPE=a>");
	// add the answer + explanation textfields
	for(int ai=1;ai<=maxanswers;ai++) {
	  addHTMLBuffer("Answer is:<input type=\"radio\" name=\"radio"+qi+ai+"\" VALUE=\"correct\">correct<input type=\"radio\" name=\"radio"+qi+ai+"\" VALUE=\"incorrect\">incorrect<br>");
	  addHTMLBuffer("<LI><INPUT TYPE=\"text\" NAME=\"answer"+qi+ai+"\" SIZE=\"60\"><P>");
          addHTMLBuffer("expl. <INPUT TYPE=\"text\" NAME=\"explain"+qi+ai+"\" SIZE=\"60\"><P>");
	  if (ai<maxanswers) 
 	    addHTMLBuffer("<HR>");
	}
	addHTMLBuffer("</OL>");
	addHTMLBuffer("<P>");      
      }
  }


  /* Post: t is added to the HTML buffer
  */
  public void addHTMLBuffer(String t) {

    HTMLBuf.append(t+'\n'); 
  }

}
