/*
 * @(#)GenerateList.java 1.0    1999/14/09
 *
 * Copyright (c) 1998, 1999 Eindhoven University of Technology. All Rights Reserved.
 *
 * This software is proprietary information of the Eindhoven University
 * of Technology. It may be used according to the GNU license.
 *
 */

package AHA;

import XmlUtils.*;
import java.util.Hashtable;
import java.util.Enumeration;
import org.w3c.dom.*;


	/**
	 * Container for all generate clauses 
	 */
public class GenerateList extends Hashtable {
	private AHA AHA;
	private String xmlfile;
	public void print(Object s) {System.out.print(s);}
	public void println(Object s) {System.out.println(s);}

	/** 
	 * Initialize the container from a file
	 */
	public void readFile() {
		try {
			XmlReader xml = new XmlReader(xmlfile);
			Element el = xml.openFile();
			//println(el.getTagName());
			NodeList nl = el.getChildNodes();
			for (int i=0; i<nl.getLength(); i++) {
				Node genitem = nl.item(i);
				Node nameNode = genitem.getFirstChild();
				Node genlistNode = genitem.getLastChild();
				String name = nameNode.getFirstChild().toString();
				String genlist = genlistNode.getFirstChild().toString();
				this.put(name,genlist.trim());
			}
		} catch (Exception e) {
			System.out.println("Error reading the GenerateList file: "+xmlfile);
		}	
	}

	/**
	 * return this
	 */
	public GenerateList getList() {
		return this;
	}

	/**
	 * Constructor initializes this with a file
	 * @param xmlfile file containing the generate clauses, in XML format
	 */
	public GenerateList(AHA AHA, String xmlfile) {
		super();
		this.AHA = AHA;
		this.xmlfile = xmlfile;
		readFile();
	}

	public GenerateList(AHA AHA) {
		this.xmlfile = AHA.getGenListFile();
		readFile();
	}
}		