package AHA;

import XmlUtils.*;
import java.util.Hashtable;
import java.util.Enumeration;
import org.w3c.dom.*;


	/**
	 * Container for all generate clauses 
	 */
public class GenerateList extends Hashtable {
	private String xmlfile;
	public void print(Object s) {System.out.print(s);}
	public void println(Object s) {System.out.println(s);}

	/** 
	 * Initialize the container from a file
	 */
	public void readFile() {
		try {
			XmlReader xml = new XmlReader(xmlfile);
			Element el = xml.openFile();
			//println(el.getTagName());
			NodeList nl = el.getChildNodes();
			for (int i=0; i<nl.getLength(); i++) {
				Node genitem = nl.item(i);
				Node nameNode = genitem.getFirstChild();
				Node genlistNode = genitem.getLastChild();
				String name = nameNode.getFirstChild().toString();
				String genlist = genlistNode.getFirstChild().toString();
				this.put(name,genlist.trim());
			}
		} catch (Exception e) {
			System.out.println("Error reading the GenerateList file: "+xmlfile);
		}	
	}

	/**
	 * return this
	 */
	public GenerateList getList() {
		return this;
	}

	/**
	 * Constructor initializes this with a file
	 * @param xmlfile file containing the generate clauses, in XML format
	 */
	public GenerateList(String xmlfile) {
		super();
		this.xmlfile = xmlfile;
		readFile();
	}


	/**
	 * Only used for testing
	 */
	public static void main(String args[]) {
		GenerateList gl = new GenerateList("xmlgenlist");
		Enumeration e = gl.keys();
		while (e.hasMoreElements()) {
			String conceptname = (String)e.nextElement();
			String conceptlist = (String)gl.get(conceptname);
			System.out.println(conceptname+" --> "+conceptlist);
		}
	}
}		