/**
 * @(#)KnowledgeConfig.java 1.0    1999/14/09
 *
 * Copyright (c) 1998, 1999 Eindhoven University of Technology. All Rights Reserved.
 *
 * This software is proprietary information of the Eindhoven University
 * of Technology. It may be used according to the GNU license.
 *
 */

package AHA;

import java.net.*;
import java.util.*;
import java.text.*;
import java.awt.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 * The class KnowledgeConfig is a servlet that lets the user
 * change his/her knowledge about some concepts. The concepts that
 * a user may change are specified by the author of the course.
 */
public class KnowledgeConfig extends AhaServlet {

	public void init(ServletConfig config) throws ServletException {
		super.init(config);
	}
	protected void service(	HttpServletRequest request, 
				HttpServletResponse response) {
		try {
			super.initService(request,response);
		} catch (AhaException ahae) {
			System.out.println(getName()+" error: "+ahae.toString());
			super.redirect(request, response);
			return;
		}

		System.out.println("KnowledgeConfig request");
		// Build the action URL of the form
		String ChangeCgi = AHA.getServletDir() + "/KnowledgeChange/"+Course+"/"+UserModel.getId();

		// Now generate the form.
		try {
			genKnowledgeList(out, ChangeCgi);
		}catch (Exception e) {
			out.println("KnowledgeConfig: "+e.toString());
			System.out.println(e.toString());
		}
	}


	/**
	 * The actual generation of the HTML form code.
	 * @param ChangeCgi The action of the form that must be generated.
	 */
	public void genKnowledgeList(PrintWriter out, String ChangeCgi) throws AhaException{
		out.println("<H3>Knowledge of Concepts</H3>");
 
		out.println("Please mark concepts you know about, and unmark concepts the system mistakenly assumes knowledge about.\n<P>");
		out.println("<FORM METHOD=\"POST\" ACTION=\"" + ChangeCgi + "\">");
 
		out.println("<TABLE>");
		Vector concepts = new Vector();
		String filename = AHA.getUserChangeableConceptsFile();
		if (filename == null) 
			throw new AhaException("Error in properties file, no ChangeableConceptsFile setting given.");
		File changeableconcepts = new File(filename);
		if (!changeableconcepts.canRead()) {
			String error = "Error: cannot read Changeable Concepts file: "+filename;
			throw new AhaException(error);
		}
		try {
			BufferedReader in = new BufferedReader(new FileReader(filename));
			String line;
			while ((line = in.readLine()) != null) {
				concepts.addElement(line);
			}
			in.close();
		} catch (Exception e) {
			throw new AhaException("An error occurred while reading Changeable Concepts file: "+filename+".");
		}
		for (int i=0; i<concepts.size(); i++) {
			String kennis = "0";
			String concept = (String)concepts.elementAt(i);
			if (UserModel.getKnowledge().containsKey(concept)) {
				kennis = (String)UserModel.getKnowledge().get(concept);
			}
			String comment = "";
			// boolean know = UserModel.getKnowledge().containsKey(concept);
			out.println("<TR>\n<TD VALIGN=\"BOTTOM\">\n<INPUT TYPE=\"TEXT\" NAME=\"KNOW_" + concept + "\" VALUE="+kennis+">" + concept + "</TD>");
			out.println("<TD VALIGN=\"BOTTOM\">" + comment + "</TD>\n</TR>");
		}
    out.println("</TABLE>");
    out.println("<INPUT TYPE=\"SUBMIT\" VALUE=\"Effectuate Changes\">");
    out.println("<INPUT TYPE=\"RESET\" VALUE=\"Reset to Previous Settings\">");
    out.println("</FORM>");
		
	}

}