package AHA;

import java.util.Vector;
import javax.servlet.http.*;
import javax.servlet.*;
import java.util.Arrays;

/**
 * The class LinkList dumps a list of HTML links generated from a Vector of pagenames.
 */

public class LinkList extends AhaServlet {
	private boolean debug = false;
	public void println(Object s) { if (debug) System.out.println(s.toString());}

	public void init(ServletConfig config) throws ServletException {
		super.init(config);
	}
		
	protected void service(HttpServletRequest request, HttpServletResponse response) {
		try {
			super.initService(request,response);
		} catch (AhaException ahae) {
			System.out.println(getName()+" error: "+ahae.toString());
			super.redirect(request, response);
			return;
		}
		println("LinkList request");
	}


	/**
	 * dumpList first sorts the list of pages, and then makes the links and
	 * dumps them to out.
	 */
	public void dumpList(Vector v){
		Object[] names = v.toArray();
		// first sort the array
		try {
			Arrays.sort(names);
		} catch (NullPointerException npe) {
			System.out.println("LinkList Error while sorting names[].");
		}

		// now dump a list of HTML links to out
		for (int j=0; j<names.length; j++) {
			String line = "<a href="+AHA.getServletDir()+"/Get/"+Course+"/"+loginid+"/"+names[j]+".xml>"+ names[j] +"</a><p>";
			out.println(line);
		}
	}

	/**
	 * The method printEndTags takes care of generating 
	 * valid HTML code, especially the close tags
	 */
	public void printEndTags() {
		Messages Messages = AHA.getMessages();
		Messages.printEndBodyTag();
		Messages.printSimpleFooter();
	}
}