/**
 * @(#)Login.java 1.0    1999/14/09
 *
 * Copyright (c) 1998, 1999 Eindhoven University of Technology. All Rights Reserved.
 *
 * This software is proprietary information of the Eindhoven University
 * of Technology. It may be used according to the GNU license.
 *
 */

package AHA;

import java.util.Hashtable;
import javax.servlet.http.*;
import javax.servlet.*;

/**
 * The class Login is a servlet that takes care of loging in an
 * existing user. The methods it shares with the Registration 
 * servlet are provided by their parent LinkList.
 *
 */

public class Login extends Entree {
	private boolean debug = false;

	public void println(Object s) { if (debug) System.out.println(s.toString());}
	public void init(ServletConfig config) throws ServletException {
		super.init(config);
	}

		
	protected void service(HttpServletRequest request, HttpServletResponse response) {
		// The contenttype has to be set now, because
		// if the user's login+password is not correct a
		// message will have to be shown
		response.setContentType("text/html");


		boolean stop = false;

		try {
			// set PrintWriter & preprocess the formparams
			super.prepare(request, response);
		} catch (AhaException ahae) {
			Messages.dumpFatal(out, "Login Error: "+ahae.toString()+"<p>Please notify the author about this error.");
			stop = true;
		} catch (Exception ee) {
			System.out.println(getName()+" Exception: "+ee.toString());
			stop = true;
		}
		
		if (!stop) {
			// now check the formparams
			boolean filledin = (loginid!=null && passwd!=null && HtDocs!=null && Course!=null
					&& Logs!=null && Title!=null && Background!=null && Language!=null);

			if (!filledin) {
				Messages.dumpFatal(out, "Login Error: Some input fields are missing. Please try again.<p>");
			} else {	// the fields have been fulled in
				try {
					// it's ok to build an AHA object
					buildAHA(request, response);
					// and add more info to AHA
					addAHAInformation(request, response);
				} catch (AhaException a) {
					Messages.dumpFatal(out, "The system was not able to create an AHA object.<p> " + a.toString());
					stop = true;
				}
				if (!stop) {
					try {
						// now add session info, for identification
						addSessionInformation(request, response);
					} catch (AhaException a) {
						Messages.dumpFatal(out, "Could not create session.<p>" + a.toString());
						stop = true;
					}
				}
				if (!stop) {
					// The user is ready to be redirected
					redirect(request, response);
				}
				if (stop) {
					System.out.println("Login stopped...");
				}
			}
		}
	}
}