package AHA;

import java.util.Hashtable;
import java.util.Vector;
import java.io.*;
import javax.servlet.http.*;
import javax.servlet.*;
import java.net.URL;
import java.net.MalformedURLException;

public class Registration extends Entree {
	private String pagelist;
	private boolean debug = true;
	public void print(Object o) { if (debug) System.out.print(o.toString());}
	public void println(Object o) { if (debug) System.out.println(o.toString());}

	Hashtable UserModelNames;


	/**
	 * The init method reads the configured parameters which tell the servlet
	 * where to find documents, log files, background image and document title.
	 *
	 * @exception ServletException        Not thrown purposely by this init
	 * method, but can be generated by the init method of the superclass.
	 */
	public void init(ServletConfig config) throws ServletException {
		super.init(config);
		UserModelNames = new Hashtable(100, (float)0.1);
		pagelist = "docs";
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) {
		println("dopost");
		service(request, response);
	}

	protected void service(HttpServletRequest request, HttpServletResponse response) {
		super.service(request, response);
		response.setContentType("text/html");
		try { 
			boolean filledin = (loginid!=null && passwd!=null && HtDocs!=null && Course!=null
                               && Logs!=null && Title!=null && Background!=null && Language!=null);
			if (!filledin) {
				throw new AhaException("Initial parameters are missing.");
			}
			AHA = new AHA(HtDocs, Logs, Course, Title, Background, Language);
			Registration(request, response, new Hashtable());
			super.addAHAInformation(request, response);
			super.addSessionInformation(request, response);
			redirect(request, response);
		} catch (Exception e) {
			System.out.println(e.toString());
			Messages.dumpFatal(out,"Registration Error: "+e.toString());
		}
	}

	public void Registration(HttpServletRequest request, HttpServletResponse response, Hashtable UserModelNames) throws AhaException, IOException{
		String FormName; String FormEmail; String FormId;
		String FormPasswd; String FormUniv; String FormDept;

		// no user id and pathname, thus registration form
		if ((FormName = request.getParameter("name")) == null)
			throw new AhaException("Registration form does not contain a 'name' field. This indicates an error in the registration form. Please notify the author that this error occurred.");
		if ((FormEmail = request.getParameter("email")) == null)
			throw new AhaException("Registration form does not contain a 'email' field. This indicates an error in the registration form. Please notify the author that this error occurred.");
		if ((FormId = request.getParameter("id")) == null)
			throw new AhaException("Registration form does not contain an 'id' field. This indicates an error in the registration form. Please notify the author that this error occurred.");
		if ((FormPasswd = request.getParameter("passwd")) == null)
			throw new AhaException("Registration form does not contain a 'passwd' field. This indicates an error in the registration form. Please notify the author that this error occurred.");
		// The following two fields are used in typical AHA courses,
		// but may not be required for some applications.
		if ((FormUniv = request.getParameter("university")) == null)
			FormUniv = "unknown university";
		if ((FormDept = request.getParameter("department")) == null)
			FormDept = "unknown department";

		// The following is used to remove possible whitespace surrounding
		// the values entered in the input fields.
		FormName = FormName.trim();
		FormEmail = FormEmail.trim();
		FormId = FormId.trim();
		FormPasswd = FormPasswd.trim();
		FormUniv = FormUniv.trim();
		FormDept = FormDept.trim();
			if (FormName.length() == 0)
				throw new AhaException("No name was entered. You must provide your name to get access to this hyperdocument.");
			if (FormEmail.length() == 0)
				throw new AhaException("No email address was entered. You must provide your email address to get access to this hyperdocument.");
			if (FormUniv.indexOf("select") != -1)
				throw new AhaException("No university was selected. You must select which university you are from to get access to this hyperdocument.");
			if (FormDept.indexOf("select") != -1)
				throw new AhaException("No department was selected. You must select which department you are from to get access to this hyperdocument.");
			if (FormId.length() == 0)
				throw new AhaException("No identification was entered. You must provide an identification to get access to this hyperdocument.");
			if (FormPasswd.length() == 0)
				throw new AhaException("No password was entered. You must provide a password for authentication procedures.");


		File CourseLogDir = new File(Logs+"/"+Course);
		if (!CourseLogDir.exists()) {
			try {
			  // Directory for log files does not exist, so we try to create it.
				File LogDir = new File(Logs);
				if (!LogDir.exists()) {
					LogDir.mkdir();
					System.out.println("Log dir "+Logs+" created.");
				}
				CourseLogDir.mkdir();
			} catch (Exception e) {
				System.out.println("Could not make Course directory: "+CourseLogDir.toString());
				throw new AhaException("Could not make Course log directory");
			}
			println("New Course log directory made: "+CourseLogDir.toString());
		}

		String userlogdir = Logs+"/"+Course+"/"+FormId;
		File UserLogDir = new File(userlogdir);
		if (!UserLogDir.exists()) {
			try {
				UserLogDir.mkdir();
			} catch (Exception e) {
				System.out.println("Could not make personal log directory: "+UserLogDir.toString());
				throw new AhaException("Could not make personal log directory for "+loginid+".");
			}
			println("New personal log directory made: "+userlogdir);
		}
		if (!UserLogDir.exists())
			throw new AhaException("Log directory (" + userlogdir + ") does not exist and cannot be created. This indicates an error in the configuration of this AHA document. Please notify the author that this error occurred.");
		String LogName = userlogdir;
		// We make the LogName a unique object that can be used for locking.
		if (!UserModelNames.contains(LogName))
			UserModelNames.put(LogName,LogName);
		LogName = (String)UserModelNames.get(LogName);

		// Now we read the logfile and construct the User Model.
		// Note: the Documentlist is needed before this,
		// because the logfile indicates which documents have been read.
		try {
			UserModel = new UserModel(AHA, LogName);
		} catch (AhaException e) {
			println("Usermodel "+LogName+" doesnt exist yet");
			UserModel = null;
		  // when an exception occurs this indicates the user does not yet
		  // exist (or it means something else is wrong with the User Model)
		  // so we ignore this error.
		  ;
		}

		if (UserModel != null) {
			println("Usermodel already exists: "+UserModel.toString());
			throw new AhaException("A usermodel with Student ID "+loginid+" already exists. "
				+ "Please check your ID, or, in case you forgot your password, send an email "
				+ "to the author of this course.");

		} else {

			if (UserModel == null) {
				UserModel = new UserModel(AHA);
			}
			if (UserModel == null)
				throw new AhaException("Creation of User Model failed. Please notify the author that this error occurred.");
			AHA.setUserModel(UserModel);
			println("Checking form input and building new usermodel");
			if (FormEmail.indexOf('@') == -1)
				throw new AhaException("The e-mail address must be complete, including your domain. (The form of a complete e-mail address is 'user@domain'.)");
			if (FormPasswd.equalsIgnoreCase(FormName) ||
				FormPasswd.equalsIgnoreCase(FormEmail) ||
				FormPasswd.equalsIgnoreCase(FormEmail.substring(0, FormEmail.indexOf('@'))) ||
				FormPasswd.equals(FormId))
					throw new AhaException("The chosen password is too easy to guess. Please try again with a more difficult password.");
			UserModel.setName(FormName);
			UserModel.setEmail(FormEmail);
			UserModel.setId(FormId);
			UserModel.setPasswd(FormPasswd);
			UserModel.setInstitute(FormUniv);
			UserModel.setDepartment(FormDept);
			UserModel.setKnowledge(new Hashtable(500,(float)0.1));
			UserModel.setVisitedList(buildNewPageList());
			UserModel.setLogFileLines(new Vector());
			UserModel.SaveUserModel(LogName);
			println("new UserModel saved");
		}
	}

	private Hashtable buildNewPageList() throws AhaException{
		Hashtable pages = new Hashtable();
		try {
			BufferedReader fin = new BufferedReader(new FileReader(HtDocs+"/"+Course+"/"+pagelist));
			while (fin.ready()) {
				String page = fin.readLine();
				pages.put(page ,new Integer(0).toString());
			}
			fin.close();
		} catch (IOException ioe) {
			System.out.println("Error reading pagelist file: "+pagelist);
			throw new AhaException("Error initializing UserModel: pagelist read error");
		}
		return pages;
	}		
}