package AHA;
import XmlUtils.*;
import Expression.*;
import java.io.*;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Iterator;
import org.w3c.dom.*;

	/**
	 * Container for the requirements for the pages
	 */

public class RequirementList extends Hashtable {
	private String xmlfile;
	public void print(Object s) {System.out.print(s);}
	public void println(Object s) {System.out.println(s);}

	/**
	 * Return a String containing a String representation of all requirements
	 */
	public String toString() {
		String s ="";
		Enumeration e = this.keys();
		while (e.hasMoreElements()) {
			String key = (String)e.nextElement();
			String value = (String)this.get(key);
			s = key+"<-"+value+"  ";
		}
		return s;
	}

	/**
	 * Read the requirements from a file
	 */
	public void readRequirements() {
		try {
			XmlReader xml = new XmlReader(xmlfile);
			Element el = xml.getRoot();
	
			NodeList nl = el.getChildNodes();
			for (int i=0; i<nl.getLength(); i++) {
				Node concept = nl.item(i);
				String name = Utils.getFirst(concept,"conceptname");
				String exprstring = Utils.getFirst(concept,"relationexpression");
				try{
					Expr expr = new Expr().parseTerm(exprstring);
					this.put(name.trim(),expr);
				} catch (Exception ee){
					System.out.println("Error in Expression: "+exprstring);
				}
			}
		} catch (Exception e) { 
			System.out.println("Error reading Requirements file: "+xmlfile);
		}
	}

	/**
	 * returns this
	 */
	public RequirementList getRelations() {
		return this;
	}

	/**
	 * Initialize from data file
	 */
	public RequirementList(String xmlfile) {
		super();
		this.xmlfile = xmlfile;
		readRequirements();
	}

	/**
	 * Write the requirements to the xmlfile
	 */
	public void writeRelations() {
                try{
                        java.io.PrintWriter bout = new java.io.PrintWriter(new java.io.FileWriter(xmlfile));
                        bout.println("<?xml version=\"1.0\"?>");
                        bout.println("<!DOCTYPE conceptrelations SYSTEM \"conceptrelations.dtd\">");
                        bout.println("<conceptrelations>");
                        Enumeration e = this.elements();
                        while (e.hasMoreElements()) {
				//Req req = (Req)e.nextElement();
                                //  String key = (String)e.nextElement();
                                //  Req req = (Req)this.get(key);
                                //bout.println(req.getXML());
                        }
                        bout.println("</conceptrelations>");
                        bout.close();
                } catch (java.io.IOException ioe) {System.out.println("Error writing xmlfile");}
		System.out.println("Relations written");
	}

	/**
	 * Used for testing only
	 */
	public static void main(String args[]) {
		RequirementList c = new RequirementList("xmlreqlist");
		// c.readRequirements();
		Enumeration e = c.keys();
		while (e.hasMoreElements()) {
			String conceptname = (String)e.nextElement();
			Expr expr = (Expr)c.get(conceptname);
			System.out.println(conceptname+" <-- "+expr.toString());
		}
	}
}		