/*
 * @(#)RequirementList.java 1.0    1999/14/09
 *
 * Copyright (c) 1998, 1999 Eindhoven University of Technology. All Rights Reserved.
 *
 * This software is proprietary information of the Eindhoven University
 * of Technology. It may be used according to the GNU license.
 *
 */

package AHA;
import XmlUtils.*;
import Expression.*;
import java.io.*;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Iterator;
import org.w3c.dom.*;

	/**
	 * Container for the requirements for the pages and concepts
	 */

public class RequirementList extends Hashtable {
	private AHA AHA;
	private String xmlfile;
	public void print(Object s) {System.out.print(s);}
	public void println(Object s) {System.out.println(s);}

	/**
	 * Return a String containing a String representation of all requirements
	 */
	public String toString() {
		String s ="";
		Enumeration e = this.keys();
		while (e.hasMoreElements()) {
			String key = (String)e.nextElement();
			String value = (String)this.get(key);
			s = key+"<-"+value+"  ";
		}
		return s;
	}

	/**
	 * Read the requirements from a file
	 */
	public void readRequirements() {
		try {
			XmlReader xml = new XmlReader(xmlfile);
			Element el = xml.getRoot();
	
			NodeList nl = el.getChildNodes();
			for (int i=0; i<nl.getLength(); i++) {
				Node concept = nl.item(i);
				String name = Utils.getFirst(concept,"conceptname");
				String exprstring = Utils.getFirst(concept,"relationexpression");
				try{
					Expr expr = new Expr().parseTerm(exprstring);
					this.put(name.trim(),expr);
				} catch (Exception ee){
					System.out.println("Error in Expression: "+exprstring);
				}
			}
		} catch (Exception e) { 
			System.out.println("Error reading Requirements file: "+xmlfile);
		}
	}

	/**
	 * returns this
	 */
	public RequirementList getRelations() {
		return this;
	}

	/**
	 * Initialize from data file
	 */
	public RequirementList(AHA AHA) {
		super();
		this.AHA = AHA;
		this.xmlfile = AHA.getReqListFile();
		readRequirements();
	}

	/**
	 * Write the requirements to the xmlfile, not in use.
	 */
	public void writeRelations() {
                try{
                        java.io.PrintWriter bout = new java.io.PrintWriter(new java.io.FileWriter(xmlfile));
                        bout.println("<?xml version=\"1.0\"?>");
                        bout.println("<!DOCTYPE conceptrelations SYSTEM \"conceptrelations.dtd\">");
                        bout.println("<conceptrelations>");
                        Enumeration e = this.elements();
                        while (e.hasMoreElements()) {
				//Req req = (Req)e.nextElement();
                                //  String key = (String)e.nextElement();
                                //  Req req = (Req)this.get(key);
                                //bout.println(req.getXML());
                        }
                        bout.println("</conceptrelations>");
                        bout.close();
                } catch (java.io.IOException ioe) {System.out.println("Error writing xmlfile");}
		System.out.println("Relations written");
	}
}		