/**
 * @(#)Stop.java 1.0    1999/14/09
 *
 * Copyright (c) 1998, 1999 Eindhoven University of Technology. All Rights Reserved.
 *
 * This software is proprietary information of the Eindhoven University
 * of Technology. It may be used according to the GNU license.
 *
 */

package AHA;

/**
 * this servlet is to be called only from the Stop-applet
 * so no session-information is available
 * so there is need for putting userinformation (name)
 * in the url
 * typical call from the Stop-applet:
 * GET http://host:port/servlets/AHA/Stop/id/docname/htdocs_course_logs_title_background_language HTTP/1.0
 */

import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Enumeration;
import java.util.Date;
import java.util.Vector;
import java.util.StringTokenizer;

public class Stop extends HttpServlet {
	private boolean debug = false;
	private AHA AHA;
	private String HtDocs;
	private String Course;
	private String Logs;
	private String Title;
	private String Background;
	private String Language;

	public void println(Object o) {if (debug) System.out.println(o.toString()); }
	public void print(Object o) {if (debug) System.out.print(o.toString()); }

	public void init(ServletConfig config) throws ServletException {
		super.init(config);
	}
			
	protected void service(HttpServletRequest request, HttpServletResponse response) {
	try {
		println("Stop Request");
		String PathInfo = request.getPathInfo();
		println(PathInfo);
		Derive d = new Derive(PathInfo);
		String Id = d.getLoginid();
		String Course = d.getCourse();
		String DocName = d.getDoc();
		println("Do some logging for "+Id+" on "+DocName);
		String AhaInfo = PathInfo.substring(PathInfo.lastIndexOf("/"));
		println("ahainfo="+AhaInfo);


		// ontrafel de initiele AHA parameters uit AhaInfo

		println("Stop ontvangt de volgende AHA parameters:");
		StringTokenizer st = new StringTokenizer(AhaInfo, "_");
		int i = 0;
		while (st.hasMoreTokens()) {
			i++;
			String value = st.nextToken();
			println(i+ ". "+value);
			switch (i) {
				case 1:		HtDocs = value; break;
				case 2:		Course = value; break;
				case 3:		Logs = value; break;
				case 4:		Title = value; break;
				case 5:		Background = value; break;
				case 6:		Language = value; break;
			}
		}

		AHA = new AHA(HtDocs, Logs, Course, Title, Background, Language);
		String LogName = new FileName(Logs, Course, Id).toString();
		try {
			System.out.print("Stop: ");
			UserModel UserModel = new UserModel(AHA, LogName);
			AHA.setUserModel(UserModel);
			Date date = new Date();
			Vector Lines = UserModel.getLogFileLines();
			String Line = "stop/" + DocName + " " + date.getTime()/1000;
			Lines.addElement(Line);
			UserModel.setLogFileLines(Lines);
			UserModel.saveUserModel(LogName);
		} catch (AhaException ae) {
			Messages messages = AHA.getMessages();
			messages.Fatal("Stop: Error writing log file");
 		}
	}catch (AhaException ahae) {
		System.out.println("Logging failed. The information from the Stop-applet is probably wrong.");
	}

	}
	protected void doGet(HttpServletRequest request, HttpServletResponse response) {
		service(request, response);
	}
}