/*
 * @(#)Todo.java 1.0    1999/14/09
 *
 * Copyright (c) 1998, 1999 Eindhoven University of Technology. All Rights Reserved.
 *
 * This software is proprietary information of the Eindhoven University
 * of Technology. It may be used according to the GNU license.
 *
 */

package AHA;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Vector;
import javax.servlet.http.*;
import javax.servlet.*;

/**
 * The servlet Todo generates a page with a list of pages that the user still has to read.
 */

public class Todo extends LinkList {
	private boolean debug = false;
	public void println(Object s) { if (debug) System.out.println(s.toString());}

	public void init(ServletConfig config) throws ServletException {
		super.init(config);
	}
		
	protected void service(HttpServletRequest request, HttpServletResponse response) {
		println("Todo request");
		super.service(request,response);

		Hashtable done = UserModel.getVisitedList();
		// output: lijst met pagina's met percentage=100
		
		out.println("<h1>List of pages you have to read<p></h1>");
		out.println("You may have already visited some pages.<p>");
		
		// names will contain the names of the todo pages
		Vector names = new Vector();

		Enumeration e = done.keys();
		while (e.hasMoreElements()) {
			String key = (String)e.nextElement();			
			String value = (String)done.get(key);
			if (!value.equals("100")) {
				// put key in the list
				names.addElement(key);
			}
		}

		// now call super.dumpList();
		super.dumpList(names);

		// make sure to generate valid HTML, so close tags
		super.printEndTags();
	}
}