package AHA;

import Expression.*;
import XmlUtils.*;
import java.util.Hashtable;
import java.util.Enumeration;
import org.w3c.dom.*;
public class ConceptsList extends Hashtable {
	private AHAclass AHA;
	private boolean debug = false;

	public ConceptsList(AHAclass AHA) {
		this.AHA = AHA;
		readXmlFiles();
	}

	private void readXmlFiles() {
		String xmlreqfile = AHA.getReqListFile();
		String xmlgenfile = AHA.getGenListFile();
		XmlReader xrreq;
		try {
			xrreq = new XmlReader(xmlreqfile);
			Element el = xrreq.getRoot();
			NodeList nl = el.getChildNodes();
			String name, exprstring;
			Expr expr;
			for (int i=0; i<nl.getLength(); i++) {
				Node item = nl.item(i);
				name = Utils.getFirst(item,"conceptname").trim();
				exprstring = Utils.getFirst(item, "relationexpression");
				try {
					expr = new Expr().parseTerm(exprstring);
				} catch (ExprException ee) {
					System.out.println("Error in Expression: "+exprstring);
					expr = new Atom("true");
				}
				Concept concept = new Concept(name, expr);
				this.put(name, concept);
			}
		} catch (Exception ahae) {
			System.out.println(ahae.toString());
		}
		XmlReader xrgen;
		try {
			xrgen = new XmlReader(xmlgenfile);
			Element el = xrgen.getRoot();
			NodeList nl = el.getChildNodes();
			String name, generateclause;
			boolean b;
			for (int i=0; i<nl.getLength(); i++) {
				Node item = nl.item(i);
				name = Utils.getFirst(item,"name").trim();
				Element e = (Element)item.getFirstChild();
				if (e.getAttribute("changeable") != null) {
					b = e.getAttribute("changeable").equalsIgnoreCase("yes");
				} else 
					b = false;
				
				generateclause = Utils.getFirst(item, "genlist");
				if (this.containsKey(name)) {
					Concept concept = (Concept)this.get(name);
					concept.setGenerates(generateclause);
					concept.setChangeable(b);
				} else {
					Concept concept = new Concept(name, generateclause,b);
					this.put(name, concept);
				}
			}
		} catch (Exception ahae) {
		        System.out.println("Failed to read xmlgenlist");
			System.out.println(ahae.toString());
		}
	}

	public void dump() {
		Enumeration e = this.keys();
		String name;
		Concept c;
		while (e.hasMoreElements()) {
			name = (String)e.nextElement();
			c = (Concept)this.get(name);
		}
	}
}
		
