/**
 * @(#)KnowledgeChange.java 1.0    1999/14/09
 *
 * Copyright (c) 1998, 1999 Eindhoven University of Technology. All Rights Reserved.
 *
 * This software is proprietary information of the Eindhoven University
 * of Technology. It may be used according to the GNU license.
 *
 */

package AHA;
import java.util.Enumeration;
import java.util.Hashtable;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 * The class KnowledgeChange reads the input that the user gave
 * in the Change Knowledge Form, and processes it.
 */

public class KnowledgeChange extends AhaServlet {
	public void init(ServletConfig config) throws ServletException {
		super.init(config);
	}

	protected void service(	HttpServletRequest request, 
				HttpServletResponse response) {
		try {
			super.initService(request,response);
		} catch (AhaException ahae) {
			System.out.println(getName()+" error: "+ahae.toString());
			super.redirect(request, response);
			return;
		}

		try {
			// Read the form input fields
			CgiUtil Util = new CgiUtil(request.getInputStream(), request.getContentLength());

			// Process the form input fields, and adapt the knowledge
			changeKnowledge(out, Util);

			// Save the new UserModel
			UserModel.saveUserModel();
			out.close();			
		} catch (Exception e) {
			out.println("KnowledgeChange Error: "+e.toString());
		}
	}


  /**
   * This method reads input from a POST request and replaces the user model
   * by the values contained in the request.
   * The form for this POST request is supposed to be the one generated by
   * the "genConfig" method.
   * There is a string parameter which contains the title for the
   * generated HTML page.
   */
  public void changeKnowledge(PrintWriter out, CgiUtil Util) {

	Hashtable newKnowledge = (Hashtable)UserModel.getKnowledge().clone();
	Hashtable newVisited = (Hashtable)UserModel.getVisitedList().clone();


	String Title = AHA.getTitle();
	for (Enumeration e = Util.keys(); e.hasMoreElements(); ) {
		String attribute = (String)e.nextElement();
		String value = (String)Util.get(attribute);
		if (attribute.startsWith("KNOW_")) {
			String concept = attribute.substring(5);
			int p=0;
			boolean ok=true;
			try {
				p = Integer.parseInt(value);
			} catch (NumberFormatException nfe) {
				ok = false;	// value is not a number
			}
			if (ok && 0<=p && p<=100) {
				newKnowledge.put(concept, value);
				if (newVisited.containsKey(concept))
					newVisited.put(concept, "0");
					// Must we do a Generate on this concept's children??????
			}
		}
	}
	UserModel.setKnowledge(newKnowledge);
	UserModel.setVisitedList(newVisited);
	out.println("<H1>" + Title + "</H1>");
 
	out.println("<H3>Configuration Setup for " + UserModel.getName() + " has been updated.</H3>");
	out.println("You can now go back and continue reading using the updated setup.");
  }

}