/**
 * @(#)KnowledgeConfig.java 1.0    1999/14/09
 *
 * Copyright (c) 1998, 1999 Eindhoven University of Technology. All Rights Reserved.
 *
 * This software is proprietary information of the Eindhoven University
 * of Technology. It may be used according to the GNU license.
 *
 */

package AHA;

import java.util.Enumeration;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 * The class KnowledgeConfig is a servlet that lets the user
 * change his/her knowledge about some concepts. The concepts that
 * a user may change are specified by the author of the course.
 */

public class KnowledgeConfig extends AhaServlet {
	public void init(ServletConfig config) throws ServletException {
		super.init(config);
	}
	protected void service(	HttpServletRequest request, 
				HttpServletResponse response) {
		try {
			super.initService(request,response);
		} catch (AhaException ahae) {
			System.out.println(getName()+" error: "+ahae.toString());
			super.redirect(request, response);
			return;
		}

		// Build the action URL of the form
		String ChangeCgi = AHA.getServletDir() + "/KnowledgeChange/"+Course+"/"+UserModel.getId();

		// Now generate the form.
		try {
			genKnowledgeList(out, ChangeCgi);
		}catch (Exception e) {
			Messages.dumpFatal(out, "KnowledgeConfig: "+e.toString()+"<p>Please notify the author about this error.");
			System.out.println(e.toString());
		}
	}


	/**
	 * The actual generation of the HTML form code.
	 * @param ChangeCgi The action of the form that must be generated.
	 */
	public void genKnowledgeList(PrintWriter out, String ChangeCgi) throws AhaException{

		String title = AHA.getTitle();
		out.println("<h1>"+title+"</h1>");

		out.println("<H3>Knowledge of Concepts</H3>");
		out.println("Please mark concepts you know about, and unmark concepts the system mistakenly assumes knowledge about.\n<P>");
		out.println("<FORM METHOD=\"POST\" ACTION=\"" + ChangeCgi + "\">");
		out.println("<TABLE>");


		boolean messageemptylist = true;
		ConceptsList ConceptsList = AHA.getConceptsList();
		Enumeration e = ConceptsList.keys();
		while (e.hasMoreElements()) {
			String name = (String)e.nextElement();
			Concept concept = (Concept)ConceptsList.get(name);
			if (concept.isChangeable()) {
				String kennis = "0";
				if (UserModel.getKnowledge().containsKey(name)) {
					kennis = (String)UserModel.getKnowledge().get(name);
				}
				String comment = "";
				out.println("<TR>\n<TD VALIGN=\"BOTTOM\">\n<INPUT TYPE=\"TEXT\" NAME=\"KNOW_" + concept.getName() + "\" VALUE="+kennis+">" + concept.getName() + "</TD>");
				out.println("<TD VALIGN=\"BOTTOM\">" + comment + "</TD>\n</TR>");
				messageemptylist = false;
			}
		}
		out.println("</TABLE>");

		if (messageemptylist) {
			out.println("Sorry, the author does <b>not<b> allow any changes to knowledge by the user.<p>");
		}

		out.println("<INPUT TYPE=\"SUBMIT\" VALUE=\"Effectuate Changes\">");
		out.println("<INPUT TYPE=\"RESET\" VALUE=\"Reset to Previous Settings\">");
		out.println("</FORM>");
	}
}
