package AHA;

import java.util.Vector;
import javax.servlet.http.*;
import javax.servlet.*;

/**
 * The class LinkList dumps a list of HTML links generated from a Vector of pagenames.
 * This class is extended by Done and Todo servlets.
 */

public class LinkList extends AhaServlet {

	public void init(ServletConfig config) throws ServletException {
		super.init(config);
	}
		
	protected void service(HttpServletRequest request, HttpServletResponse response) {
		try {
			super.initService(request,response);
		} catch (AhaException ahae) {
			System.out.println(getName()+" error: "+ahae.toString());
			super.redirect(request, response);
			return;
		}
	}


	/**
	 * dumpList first sorts the list of pages, and then makes the links and
	 * dumps them to out.
	 */
	public void dumpList(Vector v){
		// is not allowed in jdk1.1:
		// Object[] names = v.toArray();

		Object[] names = new Object[v.size()];
		for (int i=0; i<v.size(); i++) {
			names[i] = v.elementAt(i);
		}

		// Sorting will not take place.
		// jdk1.1 does not support java.util.Arrays
/*		// first sort the array
		try {
			Arrays.sort(names);
		} catch (NullPointerException npe) {
			System.out.println("LinkList Error while sorting names[].");
		}
*/
		// now dump a list of HTML links to out
		for (int j=0; j<names.length; j++) {
			String line = "<a href="+AHA.getServletDir()+"/Get/"+Course+"/"+loginid+"/"+names[j]+".xml>"+ names[j] +"</a><p>";
			out.println(line);
		}
	}

	/**
	 * The method printEndTags takes care of generating 
	 * valid HTML code, especially the close tags
	 */
	public void printEndTags() {
		Messages Messages = AHA.getMessages();
		Messages.printEndBodyTag();
		Messages.printSimpleFooter();
	}
}
