/**
 * @(#)Logout.java 1.0    1999/14/09
 *
 * Copyright (c) 1998, 1999 Eindhoven University of Technology. All Rights Reserved.
 *
 * This software is proprietary information of the Eindhoven University
 * of Technology. It may be used according to the GNU license.
 *
 */

package AHA;

import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Enumeration;

/**
 * The class Logout is a servlet that is called when a user logs out of
 * a Course. 
 */

public class Logout extends AhaServlet {
	public void init(ServletConfig config) throws ServletException {
		super.init(config);
	}

	protected void service(	HttpServletRequest request, 
				HttpServletResponse response) {
		try {
			super.initService(request,response);
		} catch (AhaException ahae) {
			System.out.println(getName()+" error: "+ahae.toString());
			super.redirect(request, response);
			return;
		}

		HttpSession session = request.getSession();
		logoutPerson(this.getServletContext(), session);
		// NB: CHANGE: de link eruit halen, want die is voor 
		// testen alleen
		out.println("Thank you for visiting "+Title+", <a href=\"/"+Course+"\" target=\"_top\">" + Course +"</a>");
	}
	private void removeUserAHA() {
		ServletContext sc = this.getServletContext();
		sc.removeAttribute(loginid+"@"+Course);
	}


	/**
	 * Log out the user from this course, and remove the session
	 * if the user was only using this course. Otherwise (the user is logged twice to the system) 
	 * don't remove the session from the system.
	 */
	public void logoutPerson(ServletContext sc, HttpSession session) {
		String outlogger = loginid+"@"+Course;

		boolean invalidate = true;
		boolean remove = true;
		Enumeration e = sc.getAttributeNames();
		while (e.hasMoreElements()) {
			String key = (String)e.nextElement();

			boolean check = true;
			Object object = sc.getAttribute(key);
			if (object instanceof AHASession) {
			} else {
				System.out.println("Object is not an AHASession. Ignore object.");
				check = false;
			}	
			if (check) {	// object is a AHASession
				AHASession ses = (AHASession)sc.getAttribute(key);
				if (ses.getSession().getId().equals(session.getId())) {
					if (!outlogger.equals(key)) {
						// this session is used for more than one user@course
						// so don't invalidate the session
						remove = true;
						invalidate = false;
					} else  {
						// this session is used only for this user@course
						remove = true;
					}
				}
			}
		}
		if (remove) removeUserAHA();
		if (invalidate) session.invalidate();
		if (!invalidate) System.out.println("Session not invalidated because it is in use.");
	}
}
