/**
 * @(#)PasswordConfig.java 1.0    1999/14/09
 *
 * Copyright (c) 1998, 1999 Eindhoven University of Technology. All Rights Reserved.
 *
 * This software is proprietary information of the Eindhoven University
 * of Technology. It may be used according to the GNU license.
 *
 */

package AHA;

import java.util.Enumeration;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 * The PasswordConfig class is a servlet that lets the user
 * change his/her password. 
 */
public class PasswordConfig extends AhaServlet {

	private String Password; // the user's password;

	public void init(ServletConfig config) throws ServletException {
		super.init(config);

	}
	protected void service(	HttpServletRequest request, HttpServletResponse response) {
		try {
			super.initService(request,response);
		} catch (AhaException ahae) {
			System.out.println(getName()+" error: "+ahae.toString());
			super.redirect(request, response);
			return;
		}

		try {
			CgiUtil Util =new CgiUtil(request.getInputStream(), request.getContentLength());
			if (Util.isEmpty()) {
				// No form data, so generate a new form
				String href = AHA.getServletDir() + "/PasswordConfig/"+Course+"/"+UserModel.getId();
				genConfig(href);
			} else {
				// There is a new password, change it.
				changeConfig(Util);
				// And save the new usermodel
				UserModel.saveUserModel();
			}
			out.close();			
		} catch (Exception e) {
			out.println("PasswordConfig: "+e.toString());
		}
	}

  /**
   * This method writes out the password as an HTML form that can be used
   * for changing the password.
   * There is one String parameter: a URL for the script or servlet to
   * handle the submitted form.
   */
  public void genConfig(String ChangeCgi) {
    String Title = AHA.getTitle();

    out.println("<H1>" + Title + "</H1>");
    out.println("<H3>Configuration Setup for " + UserModel.getName() + "</H3>");
    out.println("<FORM METHOD=\"POST\" ACTION=\"" + ChangeCgi + "\">");

    out.println("<H3>Password</H3>");
    out.println("<TABLE>");
    out.println("<TR>");
    out.println("<TD>Current:<BR></TD>");
    out.println("<TD><INPUT TYPE = \"password\" NAME = \"current\" VALUE = \"\" size = \"40\"><BR></TD>");
    out.println("</TR>");
    out.println("<TR>");
    out.println("<TD>New:<BR></TD>");
    out.println("<TD><INPUT TYPE = \"password\" NAME = \"new\" VALUE = \"\" size = \"40\"><BR></TD>");
    out.println("</TR>");
    out.println("<TR>");
    out.println("<TD>Retype:<BR></TD>");
    out.println("<TD><INPUT TYPE = \"password\" NAME = \"retype\" VALUE = \"\" size = \"40\"><BR></TD>");
    out.println("</TR>");
    out.println("</TABLE>");

    out.println("<INPUT TYPE=\"SUBMIT\" VALUE=\"Effectuate Changes\">");
    out.println("<INPUT TYPE=\"RESET\" VALUE=\"Reset to Previous Settings\">");
    out.println("</FORM>");
  }

  /**
   * This method reads input from a POST request and replaces the user model
   * by the values contained in the request.
   * The form for this POST request is supposed to be the one generated by
   * the "genConfig" method.
   * There is a string parameter which contains the title for the
   * generated HTML page.
   *
   * @exception AhaException    Thrown when the password-change is not
   * accepted.
   */
  public void changeConfig(CgiUtil Util) throws AhaException {
    UserModel UserModel = AHA.getUserModel();
    String Title = AHA.getTitle();
    out = AHA.getWriter();
  
    // complete html document
    out.println("<H1>" + Title + "</H1>");

    String currentPassword=null;
    String newPassword=null;
    String retypePassword=null;

    for (Enumeration e = Util.keys();
	 e.hasMoreElements(); ) {
      String attribute = (String)e.nextElement();
      if (attribute.equals("current")) currentPassword = (String)Util.get(attribute);
      if (attribute.equals("new")) newPassword = (String)Util.get(attribute);
      if (attribute.equals("retype")) retypePassword = (String)Util.get(attribute);
    }

    if (newPassword.equalsIgnoreCase(UserModel.getName()) ||
        newPassword.equalsIgnoreCase(UserModel.getEmail()) ||
        newPassword.equalsIgnoreCase(UserModel.getEmail().substring(0, UserModel.getEmail().indexOf('@'))) ||
        newPassword.equals(UserModel.getId()))
    throw new AhaException("The chosen password is too easy to guess. Please try again with a more difficult password.");

    if (!currentPassword.equals(UserModel.getPasswd()))
      throw new AhaException("The current password does not match the actual password.");

    if (!newPassword.equals(retypePassword))
      throw new AhaException("The two new passwords do not match.");

    UserModel.setPasswd(newPassword);

    out.println("<H3>Password for " + UserModel.getName() + " has been updated.</H3>");
    out.println("You can now go back and continue reading using the updated password.");
  }
}
