package AHA;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.net.*;

public class SaveXmlGenList extends AhaServlet {
    private int counter = 0;

    //Initialize global variables
    public void init(ServletConfig config) throws ServletException {
	super.init(config);
    }

    public void service(HttpServletRequest request,
			HttpServletResponse response) {

	++counter;

	System.out.println(counter);
	Timer t1 = new Timer();

	HttpSession session = request.getSession(false);
  	if (session!=null) synchronized(session.getId()) {
	    try {
		super.initService(request,response);
	    } catch (AhaException ahae) {
		System.out.println(getName()+": "+ahae.toString());
		ahae.printStackTrace();
		super.redirect(request, response);
		return;
	    }
	    try {
		Messages Messages = AHA.getMessages();
		String URI = request.getRequestURI();
		if (HtDocs == null)
		    throw new AhaException("The AHA Get is not initialized properly. The HTDOCS value is not set. Please notify the author that this error occurred.");
		if (Course == null)
		    throw new AhaException("The AHA Get is not initialized properly. The COURSE value is not set. Please notify the author that this error occurred.");
		if (Logs == null)
		    throw new AhaException("The AHA Get is not initialized properly. The LOGS value is not set. Please notify the author that this error occurred.");
		if (Title == null)
		    throw new AhaException("The AHA Get is not initialized properly. The TITLE value is not set. Please notify the author that this error occurred.");
		if (Background == null)
		    throw new AhaException("The AHA Get is not initialized properly. The BACKGROUND value is not set. Please notify the author that this error occurred.");
		if (Language == null)
		    Language = "English"; // the default language;
	    } catch (Exception e) {
		System.out.println(getName() + ": " + e.toString());
				// e.printStackTrace();
		try {
		    out = new PrintWriter(response.getWriter());
		} catch (IOException ioe) {
		    System.out.println(ioe.toString());
		}
				// out.println("AHA Error: "+e.toString());
		Messages.dumpFatal(out, e.toString());
	    }
	}
	try {
	    doPost(request, response);
	} catch (ServletException se) {
	    System.out.println("ServletException");
	} catch (IOException ie) {
	    System.out.println("IOException");
	}
    }

    //Process the HTTP Post request
    public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
	response.setContentType("text/html");
	File file=new File(AHA.getGenListFile());
	try {
	    FileWriter out = new FileWriter(file);
	    //Schrijf de doorgegeven variabele xmlfile naar de xmlgenlist
	    out.write(URLDecoder.decode (request.getParameter("xmlfile")) );
	    out.close();
	} catch (Exception e) {
	    System.out.println("Exception");
	}
    }

    //Process the HTTP Get request
    public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
	try {
	    response.setContentType("text/html");
	    
	    ObjectInputStream inputFromApplet=new ObjectInputStream((InputStream)request.getInputStream ());
	    Object ob=inputFromApplet.readObject ();
	    inputFromApplet.close ();

	    //Lees de xmlgenlist uit
	    File file=new File(AHA.getGenListFile());
	    FileWriter out = new FileWriter(file);
	    out.write (ob.toString ());
	    out.close();
	    //getParameter(
	    //String text = "Dit wordt door de saveServlet in de xmlgenlist gezet";
	    //out.write(text);
	    //out.close();
	} catch (ClassNotFoundException ce) {
	    System.out.println("Classnotfoundexception");
	}
    }

    //Get Servlet information
    public String getServletInfo() {
	return "tijdelijk.SaveServlet Information";
    }
}
