/**
 * @(#)Stop.java 1.0    1999/14/09
 *
 * Copyright (c) 1998, 1999 Eindhoven University of Technology. All Rights Reserved.
 *
 * This software is proprietary information of the Eindhoven University
 * of Technology. It may be used according to the GNU license.
 *
 */

package AHA;

/**
 * this servlet is to be called only from the Stop-applet
 * so no session-information is available
 * so there is need for putting userinformation (name)
 * in the url
 * typical call from the Stop-applet:
 * GET http://host:port/servlets/AHA/Stop/id/docname/htdocs_course_logs_title_background_language HTTP/1.0
 */

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Date;
import java.util.Vector;
import java.util.StringTokenizer;
import java.io.BufferedReader;

/**
 * The only purpose of this class is to get information from the Stop-applet
 * and add a line to the logfile of the user.
 */
public class Stop extends HttpServlet {
	private AHAclass AHA;
	private String HtDocs;
	private String Course;
	private String Logs;
	private String Title;
	private String Background;
	private String Language;

	public void init(ServletConfig config) throws ServletException {
		super.init(config);
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) {
	try {
		String URI = request.getRequestURI();

		Derive d = new Derive(URI);
		String Id = d.getLoginid();
		String Course = d.getCourse();
		String DocName = d.getDoc();

		// Read the data in the correct order.
		BufferedReader in = new BufferedReader(request.getReader());
		HtDocs = in.readLine();
		Logs = in.readLine();
		Course = in.readLine();
		Title = in.readLine();
		Background = in.readLine();
		Language = in.readLine();


		// now build an AHA object from that data.
		AHA = new AHAclass(HtDocs, Logs, Course, Title, Background, Language);
		// Now try to write to the user's logfile
		String LogName = new FileName(Logs, Course, Id).toString();
		try {
			// This constructor does not read a model from disk.
			// and will save us some disk read-time.
			UserModel UserModel = new UserModel(AHA);
			// not: UserModel UserModel = new UserModel(LogName);
//			AHA.setUserModel(UserModel);
			Date date = new Date();
			String line = "Stop/" + DocName + " " + date.getTime()/1000;

			// Because the UserModel is not complete (not read from disk)
			// we must provide an Id when writing to a user's logfile 
			UserModel.addLogFileLine(line, Id);

		} catch (Exception ae) {
			Messages messages = AHA.getMessages();
			messages.Fatal("Stop: Error writing log file");
 		}

	}catch (IOException ioe) {
		System.out.println("Error reading data from applet. ");
	} catch (Exception ahae) {
		System.out.println("Logging failed. The information from the Stop-applet is probably wrong.");
		System.out.println(ahae.toString());
		try {
			response.getWriter().println("Error while logging, please notify the author about this error.");
		} catch (IOException ioe) {
		}
	}

	}

	// Are these method necessary?
	protected void doGet(HttpServletRequest request, HttpServletResponse response) {
	}
}
