package Expression;

/**
 * The class Comparator contains the basic comparative operators.
 * Evaluation of expressions are done by the method compare.
 */

public class Comparator {

        final private int EQUIV = 0;            // =
        final private int LESSTHEN = 1;         // <
        final private int ATMOST = 2;           // <=
        final private int ATLEAST = 3;          // >=
        final private int MORETHEN = 4;         // >
	private int c;

	/**
	 * This constructs a new comparator from a String.
	 * An exception is thrown if the String is no known comparator.
	 */
	public Comparator(String s) throws ExprException {
		s = s.trim();
		if (s.equals("=")) {
			c = EQUIV;
		} else if (s.equals("<")) {
			c = LESSTHEN;
		} else if (s.equals(">")) {
			c = MORETHEN;
		} else if (s.equals("<=") || s.equals("=<")) {
			c = ATMOST;
		} else if (s.equals(">=") || s.equals(":") || s.equals("=>")) {
			c = ATLEAST;
		} else {	// no known comparator;
			throw new ExprException("Unknown comparator: "+s);
		}
	}

	/**
	 * returns a String representation of the comparator
	 */
	public String toString() {
		switch(c) {
		case EQUIV : return "=";
		case LESSTHEN : return "<"; 
		case ATMOST : return "<=";
		case ATLEAST : return ">=";
		case MORETHEN : return ">";
		}
		return "bla";
	}

	/**
	 * The compare method compares two integers using this comparator.
	 */
	public boolean compare(int a, int b) {
		switch(c) {
		case EQUIV : return (a==b);
		case LESSTHEN : return (a<b); 
		case ATMOST : return (a<=b);
		case ATLEAST : return (a>=b);
		case MORETHEN : return (a>b);
		}
		return true;
	}
}
