package Expression;
import java.util.Hashtable;
import java.util.StringTokenizer;

public class Expr{
	public String toString(){
		return this.toString();
	};
	public boolean eval(Hashtable hs) throws ExprException{
		return this.eval(hs);
	};

	public int count(String s, char ch) {
		return count(s,ch,s.length());
	}

	public int count(String s, char ch,int len) {
		int c=0;
		for (int i=0; i<len; i++) {
			if (s.charAt(i) == ch) {c++;}
		}
		return c;
	}
	
	public boolean haakjesoverbodig(String line) {
		int i=0;
		boolean overbodig = true;
		for (int j=0; j<line.length(); j++) {
			if (line.charAt(j)=='(') { i++;}
			if (line.charAt(j)==')') { i--;}
			if (i==0 && j>0 && j<line.length()-1) {
				//buitenste strings niet overbodig
				overbodig = false;
			}
		}
		return overbodig;
	}
	
	public String trim(String line) {
		String s = line.trim();
		while (haakjesoverbodig(s)) {
			s= s.substring(1,s.length()-1);
		//	System.out.print(".");
		} 
		return s;
	}

	public String convert(String value) {
                value = replace(value," and "," AND ");
                value = replace(value," or "," OR ");
                value = replace(value," but "," AND ");
                value = replace(value,"not ","NOT");
		return value;
	}
        public String replace(String s,String t1,String t2) {
		String r=s;
		try {
		        //vervang in s alle t1 door t2
			if (r!=null)while (r.indexOf(t1)>-1) {
	                        String left = r.substring(0,r.indexOf(t1));
				String right = r.substring(r.indexOf(t1)+t1.length(),r.length());
				if (t1.equals("not ")) right=rep(right,t1,t2);
	       	                r = left + t2 + right;
			}
		} catch (Exception e) {System.out.println(e);}//e.printStackTrace();}
	return r;
        }

	public String rep(String s, String t1, String t2) {
		// a bs --> (a) bs for "not"
		StringBuffer r=new StringBuffer(s);
	//	System.out.print("r = "+r);
		int p;
		int a, b;
		a = s.indexOf(" ");
		b = s.length();
		if (a>-1) r.insert(a,")");
		else r = r.append(")");
		// not a bs -> not(a) bs
		return "("+new String(r);
	}


	/**
	 * parseTerm parses an Expression string and returns an Expression
	 * The String may have the "old" boolean structure:
	 * readme but not html
	 * or the new percentual structure:
	 * (readme:100 AND (NOT(html:100)))
	 * Every boolean Atom will be changed to a percentual Atom, with 100%x	 
	 */





	public Expr parseTerm(String line) throws ExprException{
	try {
		line = trim(line);
		line = convert(line);
		// check if it is only an Atom
		if (!(line.indexOf(" ")>-1) && count(line,'(')==0) {
			// it is an Atom;
			Atom a = new Atom(line);
			return a;
		} else {
			StringTokenizer st = new StringTokenizer(line);
			int i=0;
			String operator="";
			String first = "";
			String last = "";
			boolean found = false;
			while (st.hasMoreElements() && !found) {
				String token = (String)st.nextElement();
				if (token.startsWith("NOT(") && i == 0) {
					operator = "NOT";
					found = true;
					last = token.substring(3,token.length());
				} else 
				if (token.equals("AND") && i ==0) {
					operator = "AND";
					found = true;
				} else 
				if (token.equals("OR") && i ==0) {
					operator = "OR";
					found = true;
				} else {
					first +=" "+token;
				}
				if (found) {
					while (st.hasMoreElements()) {
						last += " "+st.nextElement();
					}
				}

				i+= count(token,'(');
				i-= count(token,')');
			}
			first = first.trim();
			last = last.trim();
			
			if (operator.equals("NOT")) {
				return new Not(new Expr().parseTerm(last));
			} else {
				Expr a = new Expr().parseTerm(first);
				Expr b = new Expr().parseTerm(last);
				if (operator.equals("AND")) {
					return new And(a,b);
				} else {
					return new Or(a,b);
				}
			}
		}
		} catch (Exception exc) { 
			throw new ExprException("Error while parsing expression : "+line);
		} 
		
	//return new Expr();
	}
	public static void main(String[] args) throws ExprException{
		try {
			Atom a = new Atom("a>=50");
			Atom b = new Atom("a<40");
			Atom c = new Atom("a=29");
			Atom d = new Atom("a>=29");
			Expr e = new Or(a, b);
			Hashtable h = new Hashtable();
			h.put("a", "30");
			System.out.println(a.eval(h));
			System.out.println(b.eval(h));
			System.out.println(c.eval(h));
			System.out.println(d.eval(h));
			System.out.println(e.eval(h));
			
			
		} catch (ExprException ee) {
			System.out.println(ee);
		}
	}
}
