package Filter;

import org.w3c.dom.*;
import AHA.*;

public class VariableFilter extends XmlFilter {
	private AHAclass AHA;

	final String USERNAMESTRING = "username";
	final String LOGINIDSTRING = "loginid";
	final String COURSESTRING = "course";
	final String TITLESTRING = "title";
	final String NUMBERDONESTRING = "numberdone";
	final String NUMBERTODOSTRING = "numbertodo";

	public VariableFilter(AHAclass AHA, Node n) {
		super(AHA,n);
		this.AHA = AHA;
	}
	public StringBuffer Filter() throws AhaException{
		StringBuffer sb = new StringBuffer();
		sb.append(deriveVariable(node.getFirstChild().getNodeName()));
		return sb;
	}

	public String deriveVariable(String var) throws AhaException {
		String name = "";
		if (var.equals(USERNAMESTRING)) name = AHA.getUserModel().getName();
		if (var.equals(LOGINIDSTRING)) name = AHA.getUserModel().getId();
		if (var.equals(COURSESTRING)) name = AHA.getCourse();
		if (var.equals(TITLESTRING)) name = AHA.getTitle();
		if (var.equals(NUMBERDONESTRING)) {
			int p = AHA.getUserModel().getNbGoodVisited();
			name = new Integer(p).toString();
		}
		if (var.equals(NUMBERTODOSTRING)) {
			int p = AHA.getUserModel().getNbPages() - AHA.getUserModel().getNbGoodVisited();
			name = new Integer(p).toString();
		}
		if (name.equals("")) throw new AhaException("Unknown variable: "+var);
		return name;
	}

}
